#include "Test.hpp"
#include "Tests.hpp"
#include "core/utils/ArrayString.hpp"
#include "core/utils/Utility.hpp"

static void onExit(int code, void* data) {
    unsigned int i = *static_cast<unsigned int*>(data);
    Core::String32<1024> s;
    CORE_TEST_ERROR(s.append("Hello from exit #: #"));
    CORE_TEST_ERROR(s.format(code, i));
    CORE_TEST_ERROR(s.printLine());
    Core::Test::finalize();
}

int main() {
    Core::testArrayList();
    Core::testArrayString();
    Core::testArray();
    Core::testBitArray();
    Core::testBox();
    Core::testBuffer();
    Core::testBufferedValue();
    Core::testClock();
    Core::testColor();
    Core::testComponents();
    Core::testFileReader();
    Core::testFrustum();
    Core::testHashMap();
    Core::testLinkedList();
    Core::testList();
    Core::testMath();
    Core::testMatrixStack();
    Core::testMatrix();
    Core::testPlane();
    Core::testProbingHashMap();
    Core::testQuaternion();
    Core::testRandom();
    Core::testRingBuffer();
    Core::testStack();
    Core::testThread();
    Core::testUniquePointer();
    Core::testUtility();
    Core::testVector();
    Core::testView();

    unsigned int data = 123456789;
    Core::setExitHandler(onExit, &data);
    CORE_EXIT(1);

    return 0;
}
